﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Couchbase;
using Couchbase.Extensions;
using Enyim.Caching.Memcached;
using Newtonsoft.Json;

namespace MyFistCouchbaseProject
{
    class Program
    {
     
        static void Main(string[] args)
        {
            
            GetMethod();
            JsonMethod();
        }
        /// <summary>
        /// 演示Get方法
        /// </summary>
        static void GetMethod() {
            var client = CouchbaseManager.Instance;
            //var savedBeer = client.Get("new_holland_brewing_company-sundog");
            //var savedBeer = client.Get<string>("new_holland_brewing_company-sundog");
            var savedBeer = client.Get<string>("21st_amendment_brewery_cafe");
            Console.WriteLine(savedBeer);
        }

        static void CreateMethod() {
            var client = CouchbaseManager.Instance;

            var newBeer =
                @"{
                ""name"": ""Old Yankee Ale"",
                ""abv"": 5.00,
                ""ibu"": 0,
                ""srm"": 0,
                ""upc"": 0,
                ""type"": ""beer"",
                ""brewery_id"": ""cottrell_brewing"",
                ""updated"": ""2012-08-30 20:00:20"",
                ""description"": ""A medium-bodied Amber Ale"",
                ""style"": ""American-Style Amber"",
                ""category"": ""North American Ale""
                }";

            var key = "cottrell_brewing-old_yankee_ale";
            var result = client.Store(StoreMode.Add, key, newBeer);
        }

        static void RemoveMethod()
        {
            var client = CouchbaseManager.Instance;
            var result = client.Remove("cottrell_brewing-old_yankee_ale");
        }

        static void JsonMethod()
        {
            var client = CouchbaseManager.Instance;
            var newBeer = new Beer
            {
                Name = "Old Yankee Ale",
                ABV = 5.00f,
                BreweryId = "cottrell_brewing",
                Style = "American-Style Amber",
                Category = "North American Ale"
            };
            var key = "cottrell_brewing-old_yankee_ale";
            var result = client.StoreJson(StoreMode.Set, key, newBeer);

            var savedBeer = client.GetJson<Beer>(key);
            Console.WriteLine(savedBeer.Name);
        }
    }
}
